searchData={"items":[{"type":"module","title":"iso8583_erl","doc":"this module is the api file for the iso8583_erl project","ref":"iso8583_erl.html"},{"type":"function","title":"iso8583_erl.add_echo_fields/3","doc":null,"ref":"iso8583_erl.html#add_echo_fields/3"},{"type":"function","title":"iso8583_erl.check_mandatory_fields/2","doc":null,"ref":"iso8583_erl.html#check_mandatory_fields/2"},{"type":"function","title":"iso8583_erl.create_bitmap/2","doc":"for creating the final bitmap this bitmap is an 8/16 byte binary with each byte being represented by an integer. integer converted to a 2 bit binary represents presence or absence of those fields example below 8 &gt; iso8583_erl : create_bitmap ( hex , . . &lt;&lt; 0 , 0 , 1 , 1 , 1 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 &gt;&gt; ) . &quot;3800000000000000&quot; 9 &gt;","ref":"iso8583_erl.html#create_bitmap/2"},{"type":"function","title":"iso8583_erl.get_bitmap_type/1","doc":"gets the bitmap type from the specification. example below 130 &gt; iso8583_erl : get_bitmap_type ( Spec ) . hex 131 &gt;","ref":"iso8583_erl.html#get_bitmap_type/1"},{"type":"function","title":"iso8583_erl.get_field/2","doc":"this is for getting a particular field,mti,bitmap in an iso message back if getting a field,number must be between 2 and 128. example below for getting transaction amount i.e. field 4 175 &gt; iso8583_erl : get_field ( 4 , Map_message ) . { ok , &lt;&lt; &quot;0000000004.5&quot; &gt;&gt; } 176 &gt;","ref":"iso8583_erl.html#get_field/2"},{"type":"function","title":"iso8583_erl.get_size_send/2","doc":"for getting the final size of the message to be sent this is usually done because the receiver of the message expects a header containing the size of the whole message so message can be processed on the receiving end of the socket in a streaming fashion or as a one of message. the length of the header which will hold the size of the message is the second arguement. example below 11 &gt; Spec = iso8583_erl : load_specification ( code : priv_dir ( iso8583_erl ) ++ &quot;/&quot; ++ &quot;spec.cfg&quot; ) . 12 &gt; Message_send = iso8583_erl : set_field_list ( [ { mti , &lt;&lt; &quot;0200&quot; &gt;&gt; } , { 3 , &lt;&lt; &quot;201234&quot; &gt;&gt; } , { 4 , &lt;&lt; &quot;4.5&quot; &gt;&gt; } , { 5 , &lt;&lt; &quot;5000&quot; &gt;&gt; } , { 102 , &lt;&lt; &quot;123413243&quot; &gt;&gt; } , { 103 , &lt;&lt; &quot;12897979987&quot; &gt;&gt; } ] ) . #{ 3 =&gt; &lt;&lt; &quot;201234&quot; &gt;&gt; , 4 =&gt; &lt;&lt; &quot;4.5&quot; &gt;&gt; , 5 =&gt; &lt;&lt; &quot;5000&quot; &gt;&gt; , 102 =&gt; &lt;&lt; &quot;123413243&quot; &gt;&gt; , 103 =&gt; &lt;&lt; &quot;12897979987&quot; &gt;&gt; , mti =&gt; &lt;&lt; &quot;0200&quot; &gt;&gt; } 13 &gt; Iso_Response = iso8583_erl : pack ( Message_send , Spec ) . [ &quot;0200&quot; , &quot;B8000000000000000000000006000000&quot; , [ &quot;201234&quot; , &quot;0000000004.5&quot; , &quot;000000005000&quot; , [ &quot;09&quot; , &quot;123413243&quot; ] , [ &quot;11&quot; , &quot;12897979987&quot; ] ] ] 14 &gt; Final_size = iso8583_erl : get_size_send ( Iso_Response , 4 ) . &quot;0090&quot; Final_socket_send = [ Final_size , Iso_Response ] , io : format ( &quot; ~n sent server message is ~p &quot; , [ Final_socket_send ] ) , case gen_tcp : connect ( Host , Port , [ list , { active , once } ] ) of { ok , Socket } -&gt; ok = gen_tcp : send ( Socket , Final_socket_send ) , ok = gen_tcp : close ( Socket ) ; { error , Error } -&gt; error_logger : format ( &quot;Connection failed: ~ts ~n &quot; , [ inet : format_error ( Error ) ] ) end . 15 &gt;","ref":"iso8583_erl.html#get_size_send/2"},{"type":"function","title":"iso8583_erl.get_spec_field/2","doc":"gets the specification for a particular field. field number must be between 2 and 128. example below 119 &gt; iso8583_erl : get_spec_field ( 2 , Spec ) . { 19 , vl , 2 , &quot;N&quot; , { none , none } } 120 &gt;","ref":"iso8583_erl.html#get_spec_field/2"},{"type":"function","title":"iso8583_erl.get_spec_mti/3","doc":null,"ref":"iso8583_erl.html#get_spec_mti/3"},{"type":"function","title":"iso8583_erl.load_specification/1","doc":"creates a map which contains the various data elements and the bitmap type from a specification file. will throw an exception if specification file has wrong field information. example below 70 &gt; Spec = iso8583_erl : load_specification ( code : priv_dir ( iso8583_erl ) ++ &quot;/&quot; ++ &quot;spec.cfg&quot; ) . #{ 16 =&gt; { 4 , fx , 0 , &quot;MMDD&quot; , { none , none } } , 107 =&gt; { 999 , vl , 3 , &quot;ANS&quot; , { none , none } } , 115 =&gt; { 999 , vl , 3 , &quot;ANS&quot; , { none , none } } , . . . } 71 &gt;","ref":"iso8583_erl.html#load_specification/1"},{"type":"function","title":"iso8583_erl.load_specification_mti/1","doc":null,"ref":"iso8583_erl.html#load_specification_mti/1"},{"type":"function","title":"iso8583_erl.pack/2","doc":"for packing a map containing iso fields into iolist. example below 135 &gt; Spec = iso8583_erl : load_specification ( code : priv_dir ( iso8583_erl ) ++ &quot;/&quot; ++ &quot;spec.cfg&quot; ) . . . { ok , First_map } = iso8583_erl : set_mti ( maps : new ( ) , &lt;&lt; &quot;0200&quot; &gt;&gt; ) , . . { ok , Second_map } = iso8583_erl : set_field ( First_map , 3 , &lt;&lt; &quot;201234&quot; &gt;&gt; ) , . . { ok , Third_map } = iso8583_erl : set_field ( Second_map , 4 , &lt;&lt; &quot;4.5&quot; &gt;&gt; ) , . . { ok , Fourth_map } = iso8583_erl : set_field ( Third_map , 5 , &lt;&lt; &quot;5000&quot; &gt;&gt; ) , . . { ok , Fifth_map } = iso8583_erl : set_field ( Fourth_map , 102 , &lt;&lt; &quot;123413243&quot; &gt;&gt; ) , . . { ok , Six_map } = iso8583_erl : set_field ( Fifth_map , 103 , &lt;&lt; &quot;12897979987&quot; &gt;&gt; ) , . . [ Mti , Bitmap_final_bit , Fields_list ] = iso8583_erl : pack ( Six_map , Spec ) . [ &quot;0200&quot; , &quot;B8000000000000000000000006000000&quot; , [ &quot;201234&quot; , &quot;0000000004.5&quot; , &quot;000000005000&quot; , [ &quot;09&quot; , &quot;123413243&quot; ] , [ &quot;11&quot; , &quot;12897979987&quot; ] ] ] 136 &gt;","ref":"iso8583_erl.html#pack/2"},{"type":"function","title":"iso8583_erl.set_field/3","doc":"for setting the fields for an iso message field number must be between 2 and 128 example below for setting the primary account number(PAN) i.e. field 2 180 &gt; iso8583_erl : set_field ( maps : new ( ) , 2 , &lt;&lt; &quot;4846801212341234129&quot; &gt;&gt; ) . { ok , #{ 2 =&gt; &lt;&lt; &quot;4846801212341234129&quot; &gt;&gt; } } 181 &gt;","ref":"iso8583_erl.html#set_field/3"},{"type":"function","title":"iso8583_erl.set_field_list/1","doc":"for setting multiple fields at the same time if setting a field,number must be between 2 and 128 example below 183 &gt; iso8583_erl : set_field_list ( [ { mti , &lt;&lt; &quot;0200&quot; &gt;&gt; } , { 3 , &lt;&lt; &quot;201234&quot; &gt;&gt; } , { 4 , &lt;&lt; &quot;4.5&quot; &gt;&gt; } , { 5 , &lt;&lt; &quot;5000&quot; &gt;&gt; } , { 102 , &lt;&lt; &quot;123413243&quot; &gt;&gt; } , { 103 , &lt;&lt; &quot;12897979987&quot; &gt;&gt; } ] ) . #{ 3 =&gt; &lt;&lt; &quot;201234&quot; &gt;&gt; , 4 =&gt; &lt;&lt; &quot;4.5&quot; &gt;&gt; , 5 =&gt; &lt;&lt; &quot;5000&quot; &gt;&gt; , 102 =&gt; &lt;&lt; &quot;123413243&quot; &gt;&gt; , 103 =&gt; &lt;&lt; &quot;12897979987&quot; &gt;&gt; , mti =&gt; &lt;&lt; &quot;0200&quot; &gt;&gt; } 184 &gt;","ref":"iso8583_erl.html#set_field_list/1"},{"type":"function","title":"iso8583_erl.set_mti/2","doc":"this is for setting the mti of a message example below for setting the mti for a reversal(1420) 185 &gt; iso8583_erl : set_mti ( maps : new ( ) , &lt;&lt; &quot;1420&quot; &gt;&gt; ) . { ok , #{ mti =&gt; &lt;&lt; &quot;1420&quot; &gt;&gt; } } 186 &gt;","ref":"iso8583_erl.html#set_mti/2"},{"type":"function","title":"iso8583_erl.unpack/2","doc":"for unpacking a formatted iso messages from iolist/list into map format. example below 161 &gt; Spec = iso8583_erl : load_specification ( code : priv_dir ( iso8583_erl ) ++ &quot;/&quot; ++ &quot;spec.cfg&quot; ) . 162 &gt; Message . &quot;0200B80000000000000000000000060000002012340000000004.5000000005000091234132431112897979987&quot; 163 &gt; iso8583_erl : unpack ( Message , Spec ) . #{ 3 =&gt; &lt;&lt; &quot;201234&quot; &gt;&gt; , 4 =&gt; &lt;&lt; &quot;0000000004.5&quot; &gt;&gt; , 5 =&gt; &lt;&lt; &quot;000000005000&quot; &gt;&gt; , 102 =&gt; &lt;&lt; &quot;123413243&quot; &gt;&gt; , 103 =&gt; &lt;&lt; &quot;12897979987&quot; &gt;&gt; , mti =&gt; &lt;&lt; &quot;0200&quot; &gt;&gt; , bit =&gt; &lt;&lt; &quot;B8000000000000000000000006000000&quot; &gt;&gt; } 164 &gt;","ref":"iso8583_erl.html#unpack/2"},{"type":"module","title":"iso8583_process","doc":"this module is responsible for processing iso8583 messages","ref":"iso8583_process.html"},{"type":"function","title":"iso8583_process.add_echo_fields/3","doc":"for adding fields which are supposed to be echoed","ref":"iso8583_process.html#add_echo_fields/3"},{"type":"function","title":"iso8583_process.check_mandatory_fields/2","doc":"for checking mandatory fields","ref":"iso8583_process.html#check_mandatory_fields/2"},{"type":"function","title":"iso8583_process.convert_base_pad/3","doc":"this converts data between bases and also pads the data for our purposes","ref":"iso8583_process.html#convert_base_pad/3"},{"type":"function","title":"iso8583_process.create_bitmap/2","doc":"for creating the final bitmap this bitmap is an 8/16 byte binary with each byte being represented by an integer. integer converted to a 2 bit binary represents presence or absence of those fields","ref":"iso8583_process.html#create_bitmap/2"},{"type":"function","title":"iso8583_process.get_bitmap_subs/3","doc":"for getting the bitmap,mti,Data fields","ref":"iso8583_process.html#get_bitmap_subs/3"},{"type":"function","title":"iso8583_process.get_bitmap_type/1","doc":"gets the bitmap type","ref":"iso8583_process.html#get_bitmap_type/1"},{"type":"function","title":"iso8583_process.get_field/2","doc":"this is for getting a particular field or mti or bitmap in an iso message back","ref":"iso8583_process.html#get_field/2"},{"type":"function","title":"iso8583_process.get_size_send/2","doc":null,"ref":"iso8583_process.html#get_size_send/2"},{"type":"function","title":"iso8583_process.get_spec_field/2","doc":"gets the specification for a particular field","ref":"iso8583_process.html#get_spec_field/2"},{"type":"function","title":"iso8583_process.get_spec_mti/3","doc":"for getting various specification types","ref":"iso8583_process.html#get_spec_mti/3"},{"type":"function","title":"iso8583_process.load_specification/1","doc":"creats a new map specification which contains the various data elements and a bitmap from a specification file can throw an error if there are bugs in the specification","ref":"iso8583_process.html#load_specification/1"},{"type":"function","title":"iso8583_process.load_specification_mti/1","doc":"this is for loading field information for mtis","ref":"iso8583_process.html#load_specification_mti/1"},{"type":"function","title":"iso8583_process.pack/2","doc":"marshalls a message to be sent. pack all the different elements in a message into an iolist","ref":"iso8583_process.html#pack/2"},{"type":"function","title":"iso8583_process.process_data_element/4","doc":"for processing the message given the bitmap and the binary containing the data elements","ref":"iso8583_process.html#process_data_element/4"},{"type":"function","title":"iso8583_process.set_field/3","doc":"this is for setting a particular field in the message or an mti field will have to be validated and then after field is validated an entry is created as a map for it padding may be added to the field depending on the type of field as well as if its fixed or vlength","ref":"iso8583_process.html#set_field/3"},{"type":"function","title":"iso8583_process.set_field_list/1","doc":null,"ref":"iso8583_process.html#set_field_list/1"},{"type":"function","title":"iso8583_process.set_mti/2","doc":null,"ref":"iso8583_process.html#set_mti/2"},{"type":"function","title":"iso8583_process.unpack/2","doc":"this part accepts a list iso message with the header removed and extracts the mti,bitmap,data elements into a map object it also accepts a specification which will be used for getting the specifications for the message exceptions can be thrown here if the string for the message hasnt been formatted well but they should be caught in whichever code is calling the system the data is first converted into a binary before the processing is done . much faster and uses less memory than using lists","ref":"iso8583_process.html#unpack/2"},{"type":"function","title":"iso8583_process.validate_specification/1","doc":"this is for validating a specification","ref":"iso8583_process.html#validate_specification/1"},{"type":"extras","title":"iso8583_erl","doc":"iso8583_erl\n=====\n\nAn erlang library for processing iso8583 messages inspired by [erl8583],[jpos library].\n\nThis is a minimalist library for  packing and unpacking iso8583 financial messages.\n\nIt accepts a specification file which contains information about fields,mti,bitmap  for your interchange.\n\nIt then uses those specifications to then pack and unpack iso messages for your interchange.\n\nThe specification can be loaded once and then used for all packing and unpacking operations","ref":"readme.html"},{"type":"extras","title":"usage ## - iso8583_erl","doc":"the library can be used by putting the following in your rebar.config or mix.exs\n\nrebar.config\n```erlang\n{iso8583_erl,{git,\"https://github.com/nayibor/iso8583_erl.git\",{tag,\"0.4.1\"}}}\n```\n\nmix.exs\n```elixir\n{:iso8583_erl, \"~> 0.4.1\"}\n```","ref":"readme.html#usage"},{"type":"extras","title":"quickstart ## - iso8583_erl","doc":"```erlang\n\n%set mti\n\tSpecification = iso8583_erl:load_specification(code:priv_dir(iso8583_erl)++\"/custom.cfg\"),\n\t{ok,First_map} = iso8583_erl:set_mti(maps:new(), >),\n\n\n%set field\n\t{ok,Second_map} = iso8583_erl:set_field(First_map,3, >),\n\n\n%pack_data\n\t%%one way to pack data\n\t{ok,First_map} = iso8583_erl:set_mti(maps:new(), >),\n\t{ok,Second_map} = iso8583_erl:set_field(First_map,3, >),\n\t{ok,Third_map} = iso8583_erl:set_field(Second_map,4, >),\n\t{ok,Fourth_map} = iso8583_erl:set_field(Third_map,5, >),\n\t{ok,Fifth_map} = iso8583_erl:set_field(Fourth_map,102, >),\n\t{ok,Six_map} = iso8583_erl:set_field(Fifth_map,103, >),\n\t[Mti,Bitmap_final_bit,Fields_list] = iso8583_erl:pack(Six_map,Specification),\n\t%another way to pack data\n\tMap_send_list = iso8583_erl:set_field_list([{mti, >},{3, >},{4, >},{5, >},{102, >},{103, >}]),\n\t[Mti,Bitmap_final_bit,Fields_list] = iso8583_erl:pack(Map_send_list,Specification).\n\n\n%unpack data\n\t{ok,First_map} = iso8583_erl:set_mti(maps:new(), >),\n\t{ok,Second_map} = iso8583_erl:set_field(First_map,3, >),\n\t{ok,Third_map} = iso8583_erl:set_field(Second_map,4, >),\n\t{ok,Fourth_map} = iso8583_erl:set_field(Third_map,5, >),\n\t[Mti,Bitmap_final_bit,Fields_list] = iso8583_erl:pack(Fourth_map,Specification),\n\tFinal_fields = [Mti,Bitmap_final_bit,Fields_list],\n\tMap_data = #{3 =>  >,4 =>  >,5 =>  >,\n    bit =>  >,mti =>  >},\n\t?assertEqual(true,Map_data =:= iso8583_erl:unpack(Final_fields,Specification)).\n\n```","ref":"readme.html#quickstart"},{"type":"extras","title":"to create documentation ## - iso8583_erl","doc":"to create documentation run command below \n```erlang\nrebar3 ex_doc\n```\n\n\nmore examples of usage can be found in  ```test/iso8583_erl_SUITE.erl```","ref":"readme.html#to-create-documentation"},{"type":"extras","title":"acknowledgements ## - iso8583_erl","doc":"i wish to thank the creators of the jpos library from which gave a lot of great ideas.\n\ni also wish to thank the creators of erl8583 library which gave a lot of excellent ideas.\n\n[erl8583]: https://github.com/mgwidmann/erl8583\n[jpos library]: https://github.com/jpos/jPOS\n[hex]: https://hex.pm/packages/iso8583_erl","ref":"readme.html#acknowledgements"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) [2020] [Nuku Ameyibor]\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"content_type":"text/plain"}